import type { ScrollPosition, VueNode } from './interface';
import type { PropType, DefineComponent } from 'vue';
declare const _default: DefineComponent<{
    scrollPosition: {
        type: PropType<ScrollPosition>;
        default: null;
    };
    useIntersectionObserver: {
        type: BooleanConstructor;
        default: boolean;
    };
    threshold: {
        type: NumberConstructor;
        default: number;
    };
    onVisible: {
        type: PropType<() => void>;
        default: () => void;
    };
    height: {
        type: NumberConstructor;
        default: number;
    };
    width: {
        type: NumberConstructor;
        default: number;
    };
    placeholder: {
        type: PropType<VueNode>;
        default: () => void;
    };
}>;
export default _default;
