import { defineComponent as P, shallowRef as _, computed as g, onMounted as X, createVNode as b, reactive as H, onBeforeUnmount as K, watch as U, mergeProps as C, ref as Q, isVNode as p } from "vue";
function k() {
  return typeof window < "u" && "IntersectionObserver" in window && "isIntersecting" in window.IntersectionObserverEntry.prototype;
}
const N = {}, ee = (e) => {
  e.forEach((t) => {
    t.isIntersecting && t.target.onVisible();
  });
}, te = (e) => (N[e] = N[e] || new IntersectionObserver(ee, {
  rootMargin: e + "px"
}), N[e]), z = () => typeof window > "u" ? 0 : window.scrollX || window.pageXOffset, F = () => typeof window > "u" ? 0 : window.scrollY || window.pageYOffset, B = () => ({
  afterLoad: {
    type: Function,
    default: () => {
    }
  },
  beforeLoad: {
    type: Function,
    default: () => {
    }
  },
  scrollPosition: {
    type: Object,
    default: null
  },
  visibleByDefault: {
    type: Boolean,
    default: !1
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  style: {
    type: Object,
    default: () => {
    }
  },
  class: {
    type: String,
    default: ""
  },
  delayMethod: {
    type: String,
    default: "throttle"
  },
  delayTime: {
    type: Number,
    default: 300
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), ne = () => ({
  ...B(),
  effect: {
    type: String,
    default: ""
  },
  placeholderSrc: {
    type: String,
    default: ""
  },
  wrapperClassName: {
    type: String,
    default: ""
  },
  wrapperProps: {
    type: Object,
    default: () => ({})
  },
  loadedClassName: {
    type: String,
    default: ""
  }
}), re = () => ({
  scrollPosition: {
    type: Object,
    default: null
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  height: {
    type: Number,
    default: 100
  },
  width: {
    type: Number,
    default: 100
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), ie = () => ({
  scrollPosition: {
    type: Object,
    default: null
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), Y = /* @__PURE__ */ P({
  name: "PlaceholderWithoutTracking",
  props: re(),
  setup(e) {
    const t = _(), n = g(() => !e.scrollPosition && e.useIntersectionObserver && k()), a = g(() => n.value ? te(e.threshold) : null);
    function l(o = e.scrollPosition) {
      const r = t.value.getBoundingClientRect(), f = t.value.style, s = {
        left: parseInt(f.getPropertyValue("margin-left"), 10) || 0,
        top: parseInt(f.getPropertyValue("margin-top"), 10) || 0
      };
      return {
        bottom: o.y + r.bottom + s.top,
        left: o.x + r.left + s.left,
        right: o.x + r.right + s.left,
        top: o.y + r.top + s.top
      };
    }
    function d() {
      if (typeof window > "u" || t.value)
        return !1;
      const o = l(e.scrollPosition), r = {
        bottom: e.scrollPosition.y + window.innerHeight,
        left: e.scrollPosition.x,
        right: e.scrollPosition.x + window.innerWidth,
        top: e.scrollPosition.y
      };
      return r.top - e.threshold <= o.bottom && r.bottom + e.threshold >= o.top && r.left - e.threshold <= o.right && r.right + e.threshold >= o.left;
    }
    function u() {
      var o;
      d() && ((o = e.onVisible) == null || o.call(e));
    }
    X(() => {
      a.value && t.value && (t.value.onVisible = e.onVisible, a.value.observe(t.value)), n.value || u == null || u();
    });
    const i = g(() => ({
      display: "inline-block",
      height: `${e.height}px`,
      width: `${e.width}px`
    }));
    return () => b("span", {
      ref: t,
      style: i.value
    }, [e.placeholder]);
  }
});
var oe = typeof global == "object" && global && global.Object === Object && global;
const le = oe;
var ae = typeof self == "object" && self && self.Object === Object && self, ce = le || ae || Function("return this")();
const G = ce;
var ue = G.Symbol;
const L = ue;
var Z = Object.prototype, de = Z.hasOwnProperty, se = Z.toString, O = L ? L.toStringTag : void 0;
function fe(e) {
  var t = de.call(e, O), n = e[O];
  try {
    e[O] = void 0;
    var a = !0;
  } catch {
  }
  var l = se.call(e);
  return a && (t ? e[O] = n : delete e[O]), l;
}
var he = Object.prototype, ge = he.toString;
function be(e) {
  return ge.call(e);
}
var ye = "[object Null]", me = "[object Undefined]", A = L ? L.toStringTag : void 0;
function ve(e) {
  return e == null ? e === void 0 ? me : ye : A && A in Object(e) ? fe(e) : be(e);
}
function we(e) {
  return e != null && typeof e == "object";
}
var Oe = "[object Symbol]";
function Pe(e) {
  return typeof e == "symbol" || we(e) && ve(e) == Oe;
}
var Se = /\s/;
function Le(e) {
  for (var t = e.length; t-- && Se.test(e.charAt(t)); )
    ;
  return t;
}
var Te = /^\s+/;
function Ie(e) {
  return e && e.slice(0, Le(e) + 1).replace(Te, "");
}
function T(e) {
  var t = typeof e;
  return e != null && (t == "object" || t == "function");
}
var R = 0 / 0, je = /^[-+]0x[0-9a-f]+$/i, xe = /^0b[01]+$/i, Ne = /^0o[0-7]+$/i, Ee = parseInt;
function D(e) {
  if (typeof e == "number")
    return e;
  if (Pe(e))
    return R;
  if (T(e)) {
    var t = typeof e.valueOf == "function" ? e.valueOf() : e;
    e = T(t) ? t + "" : t;
  }
  if (typeof e != "string")
    return e === 0 ? e : +e;
  e = Ie(e);
  var n = xe.test(e);
  return n || Ne.test(e) ? Ee(e.slice(2), n ? 2 : 8) : je.test(e) ? R : +e;
}
var Ce = function() {
  return G.Date.now();
};
const E = Ce;
var ke = "Expected a function", Be = Math.max, We = Math.min;
function q(e, t, n) {
  var a, l, d, u, i, o, r = 0, f = !1, s = !1, v = !0;
  if (typeof e != "function")
    throw new TypeError(ke);
  t = D(t) || 0, T(n) && (f = !!n.leading, s = "maxWait" in n, d = s ? Be(D(n.maxWait) || 0, t) : d, v = "trailing" in n ? !!n.trailing : v);
  function y(c) {
    var h = a, m = l;
    return a = l = void 0, r = c, u = e.apply(m, h), u;
  }
  function W(c) {
    return r = c, i = setTimeout(w, t), f ? y(c) : u;
  }
  function V(c) {
    var h = c - o, m = c - r, x = t - h;
    return s ? We(x, d - m) : x;
  }
  function I(c) {
    var h = c - o, m = c - r;
    return o === void 0 || h >= t || h < 0 || s && m >= d;
  }
  function w() {
    var c = E();
    if (I(c))
      return j(c);
    i = setTimeout(w, V(c));
  }
  function j(c) {
    return i = void 0, v && a ? y(c) : (a = l = void 0, u);
  }
  function $() {
    i !== void 0 && clearTimeout(i), r = 0, a = o = l = i = void 0;
  }
  function M() {
    return i === void 0 ? u : j(E());
  }
  function S() {
    var c = E(), h = I(c);
    if (a = arguments, l = this, o = c, h) {
      if (i === void 0)
        return W(o);
      if (s)
        return clearTimeout(i), i = setTimeout(w, t), y(o);
    }
    return i === void 0 && (i = setTimeout(w, t)), u;
  }
  return S.cancel = $, S.flush = M, S;
}
var Ve = "Expected a function";
function $e(e, t, n) {
  var a = !0, l = !0;
  if (typeof e != "function")
    throw new TypeError(Ve);
  return T(n) && (a = "leading" in n ? !!n.leading : a, l = "trailing" in n ? !!n.trailing : l), q(e, t, {
    leading: a,
    maxWait: t,
    trailing: l
  });
}
const Me = (e) => {
  const t = getComputedStyle(e, null);
  return t.getPropertyValue("overflow") + t.getPropertyValue("overflow-y") + t.getPropertyValue("overflow-x");
}, ze = (e) => {
  if (!(e instanceof HTMLElement))
    return window;
  let t = e;
  for (; t && t instanceof HTMLElement; ) {
    if (/(scroll|auto)/.test(Me(t)))
      return t;
    t = t.parentNode;
  }
  return window;
}, Fe = (e) => /* @__PURE__ */ P({
  name: "ScrollAwareComponent",
  props: B(),
  setup(n, {
    attrs: a
  }) {
    const l = g(() => n.useIntersectionObserver && k()), d = _(null), u = H({
      x: z(),
      y: F()
    });
    if (!l.value)
      return null;
    function i() {
      l.value || (u.x = z(), u.y = F());
    }
    const o = g(() => ze(d.value));
    function r() {
      typeof window > "u" || l || (o.value.addEventListener("scroll", i), window.addEventListener("resize", i), o.value !== document.body && window.addEventListener("scroll", i));
    }
    function f() {
      typeof window > "u" || l || (o.value.removeEventListener("scroll", i), window.removeEventListener("resize", i), o.value !== document.body && window.removeEventListener("scroll", i));
    }
    X(() => {
      r();
    }), K(() => {
      f();
    }), U(o, (v, y) => {
      y && f(), r();
    });
    const s = n.delayMethod === "debounce" ? q(i, n.delayTime) : $e(i, n.delayTime);
    return () => b(e, C(n, a, {
      scrollPosition: u,
      ref: d,
      onChangeScroll: s
    }), null);
  }
}), Ae = /* @__PURE__ */ P({
  name: "PlaceholderWithTracking",
  props: ie(),
  setup(e) {
    return () => b(Y, e, null);
  }
}), Re = Fe(Ae), De = /* @__PURE__ */ P({
  compatConfig: {
    MODE: 3
  },
  name: "LazyLoadComponent",
  inheritAttrs: !1,
  props: B(),
  setup(e, {
    slots: t
  }) {
    var d, u;
    const n = H({
      visible: e.visibleByDefault ?? !1,
      loaded: !1,
      error: !1
    }), a = g(() => !!(e.scrollPosition && Number.isFinite(e.scrollPosition.x) && e.scrollPosition.x >= 0 && Number.isFinite(e.scrollPosition.y) && e.scrollPosition.y >= 0));
    U(n, (i, o) => {
      var r;
      i.visible !== (o == null ? void 0 : o.visible) && ((r = e.afterLoad) == null || r.call(e));
    }, {
      immediate: !0
    });
    const l = () => {
      var i;
      n.visible = !0, (i = e.afterLoad) == null || i.call(e);
    };
    return e.visibleByDefault && ((d = e.beforeLoad) == null || d.call(e), (u = e.afterLoad) == null || u.call(e)), () => {
      var i;
      return n.visible ? (i = t.default) == null ? void 0 : i.call(t) : a.value || e.useIntersectionObserver && k() ? b(Y, {
        height: e.height,
        onVisible: l,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width
      }, null) : b(Re, {
        height: e.height,
        onVisible: l,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width
      }, null);
    };
  }
});
function _e(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !p(e);
}
const He = /* @__PURE__ */ P({
  name: "LazyLoadImage",
  compatConfig: {
    MODE: 3
  },
  inheritAttrs: !1,
  props: ne(),
  setup(e, {
    attrs: t
  }) {
    const n = Q(!1);
    function a() {
      return n.value ? null : () => {
        var r;
        (r = e.afterLoad) == null || r.call(e), n.value = !0;
      };
    }
    function l() {
      const r = g(() => {
        const {
          class: f,
          afterLoad: s,
          beforeLoad: v,
          delayMethod: y,
          delayTime: W,
          effect: V,
          placeholder: I,
          placeholderSrc: w,
          scrollPosition: j,
          threshold: $,
          useIntersectionObserver: M,
          visibleByDefault: S,
          wrapperClassName: c,
          wrapperProps: h,
          style: m,
          loadedClassName: x,
          ...J
        } = e;
        return J;
      });
      return b("img", C({
        onLoad: a()
      }, r.value, t), null);
    }
    function d() {
      let r;
      return b(De, {
        beforeLoad: e.beforeLoad,
        class: e.class,
        delayMethod: e.delayMethod,
        delayTime: e.delayTime,
        height: e.height,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        style: e.style,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        visibleByDefault: e.visibleByDefault,
        width: e.width
      }, _e(r = l()) ? r : {
        default: () => [r]
      });
    }
    const u = g(() => n.value ? " lazy-load-image-loaded" : ""), i = g(() => n.value || !e.placeholderSrc ? {} : {
      backgroundImage: `url(${e.placeholderSrc})`,
      backgroundSize: "100% 100%"
    });
    function o(r) {
      return b("span", C({
        class: e.wrapperClassName + " lazy-load-image-background " + e.effect + u.value,
        style: {
          ...i.value,
          color: "transparent",
          display: "inline-block",
          height: e.height + "px",
          width: e.width + "px"
        }
      }, e.wrapperProps), [r]);
    }
    return () => {
      const r = d();
      return !((e.effect || e.placeholderSrc) && !e.visibleByDefault) && !e.wrapperClassName && !e.wrapperProps ? r : o(r);
    };
  }
});
export {
  De as LazyLoadComponent,
  He as LazyLoadImage,
  Fe as trackWindowScroll
};
